/* Change Program
 * Jeff Connelly
 * 28Aug2002
 * C3 L1
 */

#include <iostream.h>
#include <stdlib.h>

int prompt_cents(char* prompt);
void output_dollars(char* message, int cents);
int calc_change(int purchased);
void output_change(int change);

int main()
{
	int purchased = 0, change = 0;       // In integer cents
	char another_purchase = 'y';

	do
	{
		purchased = prompt_cents("Purchase amount: $");
		change    = calc_change(purchased);

		if (change)
		{
			output_dollars("Change: $", change);
			output_change(change);
		}

		cout << "Another purchase (y/N)? ";
		cin >> another_purchase;

		system("cls");
		
	} while (another_purchase == 'y' ||
		     another_purchase == 'Y');

	system("pause");
	return 0;
}

void output_change(int change)
{
		
	int dollars, quarters, dimes, nickels, cents;

	dollars = int(change / 100);
	change %= 100;

	quarters = change / 25; change %= 25;
	dimes    = change / 10; change %= 10;
	nickels  = change /  5; change %=  5;
	cents    = change;

	cout << "\n\nCoins needed:" << endl << endl
		 << "Dollars : " << dollars  << endl
		 << "Quarters: " << quarters << endl
		 << "Dimes   : " << dimes    << endl
		 << "Nickels : " << nickels  << endl
		 << "Cents   : " << cents    << endl;
}

// Calculate change due from amount purchased and user input
int calc_change(int purchased)
{
	int change = 0, paid = 0;

	// Loop until paid enough, either exact or with change
	do
	{
		int    deposited = 0;          // Cents

		deposited = prompt_cents("Insert : $");

		// No added coins, user is broke
		if (!deposited)
			return 1;

 		paid += deposited;
		output_dollars("Paid   : $", paid);
		change = paid - purchased;

		if (change < 0)
		{
			output_dollars("Please insert $", -change);
		}
	} while (change < 0);

	if (!change)
	{
		cout << "No change" << endl;
		return 0;
	}

	return change;
}

// Prompt for a dollar amount, and return its value in cents
int prompt_cents(char* s)
{
	double dollars;
	int    cents;

	cout << s;
	cin  >> dollars;

	cents = (int)(dollars * 100);
	return cents;
}

// Output a cents value in dollars
void output_dollars(char* s, int cents)
{
	double dollars;

	dollars = (double)(cents) / 100;

	cout << s << dollars << endl;
}
