/* Car Rental License Plate to Registration Code Conversion Calculator
 * C3 L2 - *A* [apstring version]
 * Jeff Connelly
 * 29 August 2002
 *
 * Input: make, model, aaa### license plate value
 * Output: code for aaa###
 *
 * Notes
 *   License abcxyz is same as bcaxyz, cbaxyz, acbxyz, etc.
 *   Collisions are inevitable
 *   Next time, use license as code /directly/
 *
 * (a..z=26)^3+(9)^3=17576+729=18305
 * (26)^1+(9^3)                 =755
 * (18305-755)/18305=95% chance of collision, bad design, avoid
 *
 * Examples
 *   ABC000 = Q198
 *   ACB000 = Q198
 *   BAC000 = Q198
 *   BCA000 = Q198
 *   CAB000 = Q198
 *   CBA000 = Q198
 *
 * e=(a+b+c+d)%26,a+b+c
 */

#include <iostream.h>
#include <apstring.h>
#include <stdio.h>
#include <stdlib.h>
#include <iomanip.h>

int main()
{
	char runagain = 'y';

	while(runagain == 'y')
	{
	apstring make, model, license, lp_letters;
	int sum, no;

	// This is useless, but required by specification
	cout << "Make: ";
	getline(cin, make);
	cout << "Model: ";
	getline(cin, model);
	
	cout << "License (lll-###): ";
	cin >> lp_letters >> no;

	/* Rental Car License Plate -> Registration Code Algorithm
	 *
	 * License plate=3 letters + 3 digits
	 * Sum of ASCII letters to digit value
	 * ((Sum modulo 26)th + 'A') . sum
	 * 
	 * Test case: CPR 607 = E836
	 */

	cout << endl
		 << "Make is " << make << endl
		 << "Model is " << model << endl
	     << "License plate " << lp_letters << no << " = code ";

	cout << char(((sum = lp_letters[0] + lp_letters[1] + lp_letters[2] + no) % 26) + 'A')
		 << sum << endl;

	/* Implementation Notes */
	// More compact algorithm here, less readable
	// Works but requires no space in license plate
	//cout << char(((sum = lpsz[0] + lpsz[1] + lpsz[2] + (no = atoi(lpsz + 3)) % 26) + 'A'))
	//     << sum << endl;

	cout << "Run again (y)? ";
	cin >> runagain;
	} 

	system("pause"); 

	return 0;
}
