/* Jeff Connelly
 * C5 ML2: apmatrix lab
 * 23Sep 02
 */

#include <iostream.h>
#include <apstring.h>
#include <apvector.h>
#include <apmatrix.h>
#include <stdarg.h>

apmatrix<int> $(const int xmax, int ymax, ...);

int main()
{
	char runagain;

	do
	{
		// 1. declare a "standard" (as if the STL vector isn't standard) 4x4 matrix
		int matrix[4][4];

		// 2. fill the matrix with ints 1-16, then display each to screen
		cout << "int matrix[4][4]\n";
		for (int i = 0; i < 4; i++)
		{
			for (int j = 0; j < 4; j++)
			{
				matrix[i][j] = i * 4 + j + 1;
				cout << matrix[i][j] << (matrix[i][j] >= 10 ? " " : "  ");
			}
			cout << "\n";
		}
		cout << endl;

		// 3. scale each element by 2, then display new matrix elements to screen
		cout << "scaled by 2\n";
		for (i = 0; i < 4; i++)
		{
			for (int j = 0; j < 4; j++)
			{
				matrix[i][j] *= 2;
				cout << matrix[i][j] << (matrix[i][j] >= 10 ? " " : "  ");
			}
			cout << "\n";
		}
		cout << endl;

		cout << "Press enter to see the same operations using apmatrix<int>...";
		{
			apstring ignored;
			getline(cin, ignored);
		}

		/// Do steps 1-4 using apmatrix
		
		// 1. Declare a 4x4 matrix
		// 2. Fill with ints 1-16. Function $() is used to initialize the apmatrix like builtins.
		apmatrix<int> ap = $(4, 4,
			16, 15, 14, 13, 
			12, 11, 10,  9,  
			 8,  7,  6,  5, 
			 4,  3,  2,  1);

		// 2. ...then display to screen
		cout << "apmatrix<int> ap\n";
		for (i = 0; i < 4; i++)
		{
			for (int j = 0; j < 4; j++)
			{
				cout << ap[i][j] << (ap[i][j] >= 10 ? " " : "  ");
			}
			cout << "\n";
		}
		cout << endl;

		cout << "scaled by 2\n";
		for (i = 0; i < 4; i++)
		{
			for (int j = 0; j < 4; j++)
			{
				ap[i][j] *= 2;
				cout << ap[i][j] << (ap[i][j] >= 10 ? " " : "  ");
			}
			cout << "\n";
		}
		cout << endl;

		cout << "Run again? ";
		cin >> runagain;
		cin.ignore(80, '\n');
	} while (!( runagain & ~'y'));
	return 0;
}

// Variable-argument apmatrix creation, dimensions xmax x ymax, initialized backwards
apmatrix<int> $(const int xmax, int ymax, ...)
{
	apmatrix<int> v;
	int pos = 0;
	int i, x, y;
	va_list marker;

	x = xmax;
	y = ymax;

	v.resize(xmax, ymax);
	
	va_start(marker, xmax);
	while (x > 0)
	{
		i = va_arg(marker, int);
		v[x - 1][y - 1] = (x - 1) * 4 + y;
		//cout << x - 1 << "," << y - 1 << "\t" << v[x - 1][y - 1] << endl;
		y--;
		if (!y)
			x--, y = ymax;
	}
	va_end(marker);
	return v;
}

