/* Jeff Connelly
 * C5 L2 -- apvector with functions
 * Apvector
 */

#include <iostream.h>
#include <apstring.h>
#include <apvector.h>
#include <stdarg.h>
#include <stdlib.h>

void init_vector(apvector<apstring> &v, int len, ...);
apvector<apstring> _(int len, ...);
void input_names(apvector<apstring>& names);
void show_names(apvector<apstring>& names);

int main()
{
	apvector<apstring> names;
	char runagain;
	int i;

	do
	{
		names.resize(0);

		input_names(names);
		show_names(names);

		cout << "Another go? ";
		cin >> runagain;
		cin.ignore(80, '\n');
	} while (runagain == 'y');
	system("pause");
	return 0;
}

void show_names(apvector<apstring>& names)
{
	cout << "\nReceived " << names.length() << " names: \n";
	for(int j = 0; j < names.length(); j++)
	{
		cout << j << "\t" << names[j] << endl;
	}		
}
void input_names(apvector<apstring>& names)
{	
	int i = 0;
	do
	{
		names.resize(++i);

		cout << "Enter a \"name\", blank line to quit: ";

		getline(cin, names[i - 1]);

	} while(names[i - 1].length());
	names.resize(names.length() - 1);
}

// Initialize an apvector<apstring> v to len items, using chars*
// and a variable-argument list. Similar to
//
//	apstring strings[] = { ... }
//
// but works with apvector.
void init_vector(apvector<apstring> &v, int len, ...)
{
	int pos = 0;
	apstring i;
	va_list marker;

	v.resize(len);
	
	va_start(marker, len);
	while (--len)
	{
		i = va_arg(marker, char*);
		v[pos++] = i;
		cout << "Data: " << i << endl;
	}
	va_end(marker);
}

apvector<apstring> _(int len, ...)
{
	int pos = 0;
	apstring i;
	va_list marker;
	apvector<apstring> v;

	v.resize(len);

	va_start(marker, len);
	while(--len)
	{
		i = va_arg(marker, char*);
		v[pos++] = i;
	}
	va_end(marker);
	return v;
}
