/* Jeff Connelly
 * C7 L1
 * Payments (lab extension)
 */

#include <apstring.h>
#include <apvector.h>
#include <conio.h>

double prompt_and_input_double(apstring p, double ndefault);
apstring repeat(int times, char ch);
void browse(double principle, double monthly_rate, double payment, int months);

// Screen rows
#define SCROWS 25

// 40 months, total interest 2222.73
typedef struct tagSTATEMENT
{
	int month;
	double principle;
	double interest;
	double payment;
	double balance;
} MONTHLY_STATEMENT;

int main()
{
	/*while (!_kbhit())
		;
	cout << int(_getch()) << endl;
	cout << int(_getch()) << endl;
	return 0;*/
	
	char runagain;

	do
	{
		cout << "Fill in the following fields, or just press enter to get the value in brackets\n"
		<< endl;

		double principle, monthly_rate, payment, months;

		principle = prompt_and_input_double("Principle", 10000.);
		monthly_rate = prompt_and_input_double("Annual interest rate%", 12.) / 1200;
		payment = prompt_and_input_double("Monthly payment", 300.);
		//diff
		months = prompt_and_input_double("Months to iterate", 10);

		browse(principle, monthly_rate, payment, (int)months);
		cout << endl << endl << "Run again(y): ";
		cin >> runagain;
	} while (runagain == 'y');
	return 0;
}

void browse(double principle, double monthly_rate, double payment, int months)
{
	apvector<MONTHLY_STATEMENT> statements;
	int current_month;
	double interest, total_interest;

	// Set text mode 80x50
	system("mode con lines=25");	

	current_month = 0;
	// payment=investment
	cout << "Month\tPrinciple\tInterest\tInvestment\tBalance" << endl;
	do
	{
		statements.resize(statements.length() + 1);
		statements[statements.length() - 1].principle = principle;
		
		++current_month;
		interest = principle * monthly_rate;
		principle = principle + interest +payment; // New balance(diff: + not -)
		
		statements[statements.length() - 1].month     = current_month;
		
		statements[statements.length() - 1].interest  = interest;
		statements[statements.length() - 1].payment   = payment;
		statements[statements.length() - 1].balance   = principle;

		total_interest += interest;

	} while(--months); //diff months
	cout << "Total interest: " << total_interest << endl;

	system("cls");
	int lines = 0;

	int i = 0;
	for(;;)    // loop has init/test/change in loop for increased flexibility
	{
#define to(x) x##t##o/*nothing to see here*/
		if (i > statements.length() - 1)    // if last statement, give user control
			to(go) CONTROL;

		if (i < 0)
			i = 0;
		cout << statements[i].month << "\t" <<
			statements[i].principle << "\t\t" <<
			statements[i].interest << "\t\t" <<
			statements[i].payment << "\t" <<
			statements[i].balance << "\t\t\t" << endl;
		lines++; 
		// If either on a screen 
		if (lines == SCROWS - 1 || i == statements.length() - 1)
		{ CONTROL:
			int cmd;
			apstring prompt = "Month   Principle       Interest     Payment    Balance (F1=help): ";
				//"(more) use up/pgup/dn/pgdn/end/home/esc/insert keys: ";

			cout << prompt << flush;
			//getline(cin, command);
			while (!_kbhit())
				;
			cmd = _getch();
			
			// Backspace over the prompt, clearing it
			cout << repeat(prompt.length() + 1, 8) << flush;

			if (cmd == 224)  // extended keycode requires 2nd getch
				cmd = 224 + _getch();
			if (cmd == 0)    // other form of an extended keycode, 256 + 59=F1
				cmd = 256 + _getch();
			
			if (cmd == 224 + 72) { // (up arrow) previous line
				system("cls"); // CLS is an easy way to go to (0,0), but not good
				lines = 0;
				i -= SCROWS - 1;
				continue;
			} else if (cmd == 224 + 73) { // (pg up) previous page
				lines = 0;
				i -= SCROWS;
				continue;
			} else if (cmd == 224 + 80 || cmd == 13) { // (down arrow/enter) next line
				lines--;
				i++;
				continue;
			} else if (cmd == 224 + 81 || cmd == 32) { // (pg down/space) next page
				lines = 0;
				continue;
			} else if (cmd == 224 + 79) { // (end) last page
				lines = 0;
			} else if (cmd == 224 + 71) { // (home) first page
				lines = 0;
				i = 0;
				continue;
			} else if (cmd == 27) { // (escape) quit
				break;
			} else if (cmd == 256 + 59) { // (F1) help
				system("cls");
				cout << "-- Interest Help System ---" << endl;
				cout << "Up             Previous line\n" 
					    "PgUp           Previous page\n"
						"Down/Enter     Next line\n"
						"PgDn/Spacebar  Next page\n"
						"End            Last page\n"
						"Home           First page\n"
						"Insert         Take out a loan\n"
						"Delete         Sell your stock" << endl;
				system("pause");
				system("cls");
				continue;
			} else if (cmd == 224 + 82) { // (insert) take out a loan
				system("start http://www.bankofamerica.com/loansandhomes/index.cfm/");
			} else if (cmd == 224 + 83) { // (delete)
				system("start http://finance.yahoo.com/");
			}
		}
		i++;
	}
}

double prompt_and_input_double(apstring p, double ndefault)
{
	apstring input_buffer;
	double no;

	cout << p << " [" << ndefault << "]: ";
	getline(cin, input_buffer);
	no = atof(input_buffer.c_str());
	if (!no)
		no = ndefault;
	return no;
}

// Repeats CH, TIMES number of times
// Equivalent to the Perl code ch x times
apstring repeat(int times, char ch)
{
	apstring str;

	while(--times)
		str += ch;
	return str;
}
