/* Jeff Connelly
 * Chapter 8 RPG        150 lines
 * 18Oct 2002
 */

#include <iostream.h>
#include <apstring.h>
#include <bool.h>

/* resources:
 http://cryptome.org/ - real-life documents on the decaying state of freedom
 http://tuxedo.org/~esr/jargon/ - hacker jargon, the munged version (thanks ESR! not)
*/

void library();
void start();
void revelation();
void trinary_hacker();
void disasm_into_trinary_computer();
int getchoice(int max);
void win();
void in_msu();
void in_russia();

bool expert = false;
bool have_binary = false;
bool alive = true;

// Spoiler at end
// This game is simple and doesn't have battles, but it works

int main()
{
	apstring again;

	while(alive)
	{
		cout << "Welcome to \"The Post-Binary War of Quantum and Trinary Computers\"" << endl << endl;
		cout << "To abort mission, press Control-C at any time." << endl << endl;
		while(alive)
			start();
		cout << "Play again?(y) ";
		getline(cin, again);
		if (again.length() > 1 && again[0] == 'y')
			alive = true;
	}
	return 0;

}

int getchoice(int max)
{
	apstring str;
	int choice;

	for(;;)
	{
		cout << "Enter choice: ";
		getline(cin, str);
		if (str.length() == 0)
			continue;          // null string, try again
		choice = str[0] - 'a'; // a=0, b=1, and so on
		if (choice < 0 || choice > max)
			continue;          // out of range
		else
			break;
	}
	return choice;
}

void win()
{
	cout << "You get a hold of the trinary manual and learn of the deep" << endl
		<< "secrets of PC3's. With this information, you're able to build" << endl
		<< "a prototype and mass-produce millions of unrestricted PC3's" << endl
		<< "quite easily. Despite being useful for certain tasks, entangled" << endl
		<< "quantum computers cannot compete. The MPAUSE crumbles; quantum" << endl
		<< "computers are removed from their restrictions and used for" << endl
		<< "legitimate, useful purposes. Trinary and quantum computers have" << endl
		<< "found their place, and the computing industry lives happily ever after." << endl;
	system("pause");
	exit(0);
}

void in_msu()
{
	int ch;

	while (alive)
	{
		cout << "The University guards won't let you in; they demand Quantum ID Chip." << endl
     		<< endl
			<< "a) Run around to the backdoor and try to get in" << endl
 			<< "b) Attempt to mug a student and secretly forge their" << endl
	 		<< "   identification chip" << endl;
		if (have_binary)
			cout << "c) Using the old binary circuits you got from Fry's to" << endl
				 << "   build a one-to-one replica of the identification chip" << endl;
		else
			cout << "c) NOP" << endl;
		cout << "d) Kill the mechanical guards using the sharp side of your" << endl
			 << "   binary computer monitor." << endl
			 << "e) <-- Go back" << endl;
		ch = getchoice(4);
		switch(ch)
		{
		case 0: cout << "You try to run, but crash and turn into a backdoor." << endl
					<< "Segmentation fault - brain dumped" << endl; alive = false;
			break;
		case 1: cout << "Forging a student identification chip is trivial, but" << endl
					<< "quickly detected by the University Security Commission" << endl
					<< "and you are detained. Black helicopters sweep out of the" << endl
					<< "sky and you're captured." << endl; alive = false;
			break;
		case 2: if (!have_binary)
				{
					cout << "Fatal Error: (Binary) motherboard not found" << endl;
				} else {
					cout << "The binary replica fools the guards, and you're let in!" << endl;
					win();
				}
				break;
		case 3: cout << "you die" << endl; alive = false;
			break;
		case 4: return;
		}
	}
}
	
void in_russia()
{
	int choice;

	while(alive)
	{
		cout << "You're now in Russia, where do you want to go? For a hint," << endl
			<< "press Alt-Tab and view the IE window." << endl
			<< endl
			<< "b) Moscow State University" << endl
			<< "c) Moscow State Library" << endl
			<< "a) Moscow State Times" << endl
			<< "c) Moscow State State" << endl
			<< "e) <-- Go back" << endl;
		system("start /m http://www.computer-museum.ru/english/setun.htm");

		choice = getchoice(3);
		switch(choice)
		{
		case 0: cout << "You go to the state newspaper and get lost on the way," << endl
					<< "then get caught by the International Quantum Police. Try again. " << endl;
					alive = false; break;
		case 1: cout << "You drive to the MSU after reading about the development of" << endl
					<< "trinary computers here, in /Soviet Computer Technology/, Communications" << endl
					<< "of the ACM. " << endl; 
				in_msu();
			break;
		case 2: cout << "The state (library) is nowhere to be found" << endl; 
			break;
		case 3: return;
		}
	}
}

// Start building a trinary computer, only can reach if expert==1
void disasm_into_trinary_computer()
{
	cout << "Congratulations! You take apart your electronic digital" << endl
	 << "watch and masterfully assemble its Quartz and Lithium into" << endl
	 << "a rudimentary, but working, bipolar power supply for your" << endl
	 << "Quantum-free trinary computer. You need more parts." << endl
	 << endl;

	while(alive)
	{
		// This is needed because C++, in its infinite wisdom, cannot accept labels
		int break_while = 0;
		int choice;

		cout 
			 << "a) Drive to Fry's" << endl
			 << "b) Walk to Intel" << endl
			 << "c) Go to AMD" << endl
			 << "d) Fly to Russia" << endl
			 << "e) <-- Go back" << endl;

		choice = getchoice(3);

		switch(choice)
		{
		case 0: cout << "You drive to Fry's, but they are fully stocked with evil Quantum" << endl
					 << "Computers. You're looking for Trinary Computing Parts, not QC's. " << endl
					 << "They have some old binary chips, which you take. These ICs" << endl
					 << "could be useful later for interfacing to old binary PCs." << endl
					 << endl;
		   have_binary = 1;
		   break;
		case 1: cout << "Intel's HQ is right around the corner, so you walk there. " << endl
					 << "However, when inquiring about non-Quantum circuits, they call " << endl
					 << "for the guards, and you're put in prison." << endl;
		   break_while = 1; alive = false;
		   break;
		case 2: cout << "You go to AMD's grave in Casualities of Competitors, behind" << endl
					 << "Intel's high-capacity fabrication plant. You place flowers there," << endl
					 << "knowing AMD's emminent death triggered reception of QC's; AMD would" << endl
					 << "have competed by putting out unrestricted Trinary Computers." << endl
					 << endl;
			break;
		case 3: cout << "You fly to Russia, landing in Moscow. You manage to avoid being" << endl
					<< "searched at the airport, and pass through the gate unmolested." << endl
					<< endl;
			in_russia();
			break;
		case 4: return;
	}
   }
}

void start()
{
	int choice;
	apstring n;

	while(alive)
	{
		cout << "You awake at your computer desk in the year 2600, New Years Day. For decades," << endl
			 << "humanity has been ran on Quantum Computers (QC's), and the SECPDP brand " << endl
			 << "by MPAUSE has dominated the QC market. Yet, no written history exists " << endl
 			 << "before 2020 -- and you become suspicious of this fact. Was their an " << endl
 			 << "unrestricted computer technology before 2020? This fateful day, you might" << endl
	 		 << "decide to attempt to find out." << endl
			 << endl
			 << "a) Get up and turn the TV" << endl
			 << "b) Go outside and get some badly needed sun" << endl
			 << "c) Look for your PC" << endl
			 << "d) Scavenge for parts to build a new PC" << endl;
		if (expert)
			 cout << "e) Review your revolutionary Trinary Computing Manual" << endl;
		cout << "f) Go back" << endl;

		choice = getchoice(6);
		switch(choice)
		{
		case 0: cout << "You find the remote and turn to channel 11, and spend the rest " << endl
					   << "of your life watching television. Now you're one of the mindless" << endl
					   << "zombies of the United States of America, nothing could concern" << endl
					   << "you less than the rights of computer consumers. Game over." << endl;
			alive = false;
			break;
		case 1: cout << "You go outside to get some sun, but stay out too long and get " << endl
					   << "skin cancer. Nice move. Game over." << endl;
			alive = false;
			break;
		case 3: if (!expert)
				{
					  cout << "You try to take apart your generator, ignoring the NO USER SERVICE, "<<endl
					   << "warning, and suffer a 420V shock of 3A current. Curiously, the " << endl
					   << "current seems to have been artificially inflated for Security Reasons."
					   << endl
					   << "Next time, don't attempt what you know you cannot do." << endl;
					  alive = false;
				} else {
					disasm_into_trinary_computer();
				}			
			break;
		case 2: cout << "You search around for your PC, a soft breeze ruffles a small " << endl
					  << "parchment of papers alongside your desk. You read the note: " << endl
	<< "--------------------------------------------------------" << endl
	<< "Welcome to _____,\n"
	"Your insecure Programmed Computer (PC) has been replaced by a Secure \n"
	"Environment Computing Programmed Digital Processor (SECPDP). Your quantum\n"
	"SECPDP is compatible with the following secure trusted Digital Rights \n"
	"Management (DRM) standards: \n"
	"+ Security System Standards and Certification Act (SSSCA)\n"
	"+ Intel's Trusted Platform Computing Alliance (TCPA)\n"
	"+ Microsoft-Universal-Disney Palladium\n"
	"+ United States of America Global ID Integrated Smartcard\n"
	"+ Adobe eBook SDR Substitution Cipher\n"
	"  for protecting your personal digital security needs\n"
	"+ Quantum Entanglement Remote Access Facility\n" << endl
	<< "We have seized and recycled your Programmable Computer (PC). No animals" << endl
	<< "where harmed during recycling of your machine. If you require any " << endl
	<< "technical support, please call us at 1-800-SEC-PDPS." << endl
	<< endl
	<< "To access your Consumer Manual eBook, please use the enclosed"  << endl
	<< "Asymmetric Key." << endl
	<< "Sincerely Yours," << endl
	<< "M.P.A.U.S.E. Human Relations Security Trusted Services" << endl
	<< "--------------------------------------------------------" << endl;
			cout << "You put down the letter in disgust." << endl;
		
			
			cout << "A torn manual entitled \"MPAUSE SECPDP Consumer Manual\" lays" << endl
				 << "strewn across your desk. The key is nowhere to be found. " << endl
				 << "Maybe the library will have an extra copy." << endl;
			library();
			break; 
		case 4: cout << "You review the Trinary Programming Manual and become refreshed" << endl
					<< "Now you feel confident to build your own ternac." << endl;
			break;
		case 5: return;
		case 6: cout << "c<enter>caeedadbc" << endl;
		} 
	}
}
void trinary_hacker()
{ 
	cout << "Congratulations, you now are a Trinary Computing expert." << endl;
	expert = 1;
}

void revelation()
{
	int choice;

	cout << "Finally, it all becomes clear. Binary Programmable Computers (PC2's) have" << endl
		<< "outgrown their usefulness, following release of AMD's 20GHz microprocessor in" << endl
		<< "2015. Fractically, the industry searched for a long-term solution." << endl << endl
		<< "The two options where Quantum Computers (QC's) and Trinary Programmable Computers" << endl
		<< "(PC3's). Trinary computers where clearly superior, although the newly-formed" << endl
		<< "MPAUSE (which you now known is the Media Patrol Alliance United Serving Earth)," << endl
		<< "has bought several politicians and pushed for remotely-controlled QC's." << endl
		<< "Due to their Quantum Entanglement properties, every MPAUSE QC, sold under" << endl
		<< "the name SECPDP, is remotely-controllable by the MPAUSE by its Remote Access" << endl
		<< "Facility molecule." << endl << endl
		<< "Horrified, you know what you have to do: bring computers back to the people." << endl
		<< "Overthrow the MPAUSE-mandated world government, and reveal Trinary *Programmable*" << endl
		<< "Computers, as opposed to *Programmed* Digital Processors. To do this you must" << endl
		<< "become an expert on Trinary Computing." << endl << endl;
	
	while(alive)
	{
		cout
			<< "a) Read a detailed document on Trinary Computing" << endl
			<< "b) Give up; you're content with Quantum Computers" << endl
			<< "c) Reboot" << endl
			<< "d) Test compatibility of Quantum and Trinary Computers" << endl
			<< "e) <-- Go back" << endl;
		choice = getchoice(4);
		switch(choice)
		{
		case 0: cout << "Thoroughly read this document, cover cover-to-cover several times" << endl;
			system("start http://jeff.tk/trinary/"); 
			trinary_hacker();
			break;
		case 1: cout << "\t\"First they came for the Communists;\n"
					  "\tI did not speak, because I was not a Communist.\n"
					  "\tThen they came for Jews;\n"
					  "\tI did not speak, because I was not a Jew.\n"
					  "\tAfterwards, they came for the Catholics;\n"
					  "\tI did not say anything, because I was a Protestant.\n"
					  "\tEventually, they came for me,\n"
					  "\t...and there was no one left to speak...\"\n"
					  "-- Martin Niemoller, Pastor\n"
					  "   Dachau, 1942\n"
					  << endl; 
			alive = false; break;
		case 2: cout << "You attempt to reboot, but your bridge between reality and...";
			system("rundll shell.dll,RestartDialog"); break;
		case 3: cout << "You attempt to test your SECPDP, and are infilitrated by the" << endl
					  << "keyboard's quantum entanglement reactive angents, becoming a" << endl
					  << "zombie to the MPAUSE, worse than Nimda+CodeRed+BugBear. You spend" << endl
					  << "the rest of your life dancing for Britney Spears." << endl;
			alive = false; // for all intents and purposes
			break;
		case 4:	return;
		}
	}
}


void library()
{
	int choice;

	while(alive)
	{
		cout << "You decide to go the library, so you do. The librarian asks you how she" << endl
			 << "can help you." << endl << endl
			 << "a) Give her a blank stare, you don't know why you're here" << endl
			 << "b) Ignore her and head over to the local SECPDP's to" << endl
			 << "   play some Internet games" << endl
			 << "c) Ask her about pre-2020 history" << endl
			 << "d) Find the fiction section and read some post-2020 brainwash" << endl
			 << "e) <-- Go back" << endl;

		choice = getchoice(4);
		switch(choice)
		{
		case 0: cout << "The librarian thinks you're a terrorist and reports you to the" << endl
					   << "local Terrorist Elimination Unit, you lose." << endl;
			alive = false; break;
		case 1: system("start http://www.freearcade.com/"); 
				cout << "You play the games and become one of the millions of" << endl
					<< "mindless zombies of America. Saving the IT couldn't concern" << endl
					<< "you less." << endl;
				alive = false; break;
		case 2: cout << "The librarian is more than helpful in detailing the reason" << endl
					  << "why no 2020 history exists. While there you run into Jorge" << endl
					  << "Gonzales, who happens to be asking the same question. You" << endl
					  << "obtain the elusive \"SECPDP Manual\" and overhear . . ." << endl;
					 // system("start http://www.migrantprogrammer.com/html/adventures/reed/reed2.htm");
				revelation();
				break;
		case 3: cout << "The post-2020 brainwash brainwashes you. Game over." << endl;
			alive = false; break;
		case 4: return;
		}
	}
}

int extra()
{
	apstring choice;

	cout << "It is year 2600." << endl
	     << "You awake at your computer desk and feel a sense of loss as your " << endl
		 << "hardware is nowhere to be found. Your unrestricted programmed digital " << endl
		 << "processor has been seized by the US government for not being infected " << endl
		 << "by the virus which is the media-conglomerant-endorsed standard known as " << endl
		 << "Security Systems Standards and Certification Act (SSSCA). Coupled " << endl
		 << "with Intel's Trusted Platform Computing Alliance (TCPA), your \"secure\"" << endl
		 << "computer is worse than useless as all copying-operations are federally" << endl
		 << "restricted and controlled by the Media Patrol Alliance Union of Secure Environments (MPAUSE)." << endl 
		 << "A soft breeze ruffles a small parchment of papers alongside your New World " << endl
		 << "Secure Computing Environment Programmed Digital Processor (NWSCEPDP)" << endl
		 << endl
		 << "A. Read notes alongside your brand-new NWSCEPDP" << endl
		 << "B. Attempt to login to your brand-new NWSCEPDP" << endl;
		 
	cin >> choice;
	switch(tolower(choice[0]))
	{
	case 'a': cout << "You pick up the notes and read them, and learn of the horrible loss " << endl
				   << "of unrestricted Programmed Computers (PC's). The present is nothing " << endl
				   << "like the past; no longer can add a+b quickly and efficiently. However " << endl
				   << "traditional computing technology is still in use, despite wide-spread " << endl
				   << "advances in Quantum and Trinary Computing. Educated, you now feel " << endl
				   << "confident enough to take on the MPAUSE and begin to head out to the street. " << endl;
		break;
	case 'b': cout << "You attempt to login to your NWSCEPDP, you are infiltrated via " << endl
				   << "the keyboard's reactive agents and become a zombie to the MPAUSE." << endl
				   << "The rest of your life is spent dancing for Britney Spears." << endl
				   << "Game over." << endl;
		exit(0); break;
	}
	return 0;
}

// The answers:
// ccaeedadbc      - end of file, 450 lines