/* Jeff Connelly
 * 05 Nov 2002
 * Pascal's Triangle
 */

// Added Value Feature!!!  Notepad for output

// NOTICE
//    See lab3s.cpp for a simplified, less-featured version

#include <iostream.h>
#include <apvector.h>
#include <apstring.h>
#include <stdlib.h>
#include <windows.h> 

// Useful utility functions
apstring rep(int ch, int n);            // Repeat ch n times
apstring space(int n);                  // Return spacing string of n characters
int digits(int n);                      // Count decimal digits in n
void send_text(HWND w, apstring s);     // Send WM_CHARs to window
void go();                              // Function

// DO CHANGE
const int SPACING = 5;
//const int SPACING = 10;

// Screen width, only 79/80 is used so (79-1)/2 is an integer
const int SCRWID = 80;
//const int SCRWID = 100;

int main()
{
	cout << "Pascal's Triangle Calculation (^C=Quit)" << endl << endl;
	while(1)
	{
		go();
	}
	return 0;
}

void go()
{	                               //  1
	apvector<int> row(2, 1);       // 1 1
	apvector<int> last;
	int max = 15;
	HWND window;
	apstring out;
	int n_tries = 0;

	// If there already is a Notepad, no need to start it again
	if (window = ::FindWindow("Notepad", NULL))
	{
		window = ::GetDlgItem(window, 0x0F);
		send_text(window, "\n" + rep('-', SCRWID-1) + "\n");
	} else {
		system("notepad");
	}
	
	// It is important to have an input here to let Notepad start up
	cout << "Iterate until row [15]# ";
	getline(cin, out);
	if (out.length() == 0)
		max = 15;
	else
		max = atoi(out.c_str());
	if (!max)
		return;
	max += 2;

	do  // Hang until Notepad is found
	{
		if (n_tries > 10000)
		{
			cout << "Failed to start Notepad. Pen and paper required." << endl;
		}
		n_tries++;
		window = ::FindWindow("Notepad", NULL);
		if (!window)
			continue;
		window = ::GetDlgItem(window, 0x0F);
		if (!window)
			continue;
	} while(0);

	// (n..)(x)(n..), sum = SCRWID
	// SCRWID / 2 = center, - digits(x) is first n
	out = space(SCRWID / 2 + 1) + "1\n";               // Triangle apex = 1
	cout << out; 
	send_text(window, out);

	// First rows are known, calculate the rest
	for(int n = 3; n < max; n++)
	{
		int linelen = 0;

		last = row;
		row.resize(n);

		//row[0] = row[row.length() - 1] = 1;             // L-R edges always 1
		row[0] = row[n - 1] = 1;
		
		for(int a = 0; a < row.length() - 1; a++) 	      // Inner calculation 
		{			
			if (a != 0 && a != row.length() - 2)
				row[a] = last[a - 1] + last[a];           // v Calculate line length
			linelen += (5 - digits(row[a])) + digits(row[a]);
		}

		// For second line, (all chars) / 2 = SCRWID
		// (all chars) = length(all_digits + all_spaces = all_digits * WIDTH)
		//cout << space(SCRWID / (2 * digits

		out = space((SCRWID - linelen) / 2);
		cout << out;
		send_text(window, out);
		for(int i = 0; i < row.length() - 1; i++)
		{
			// This is needed to convert digits to a string for output with send_text
			char* q = new char[digits(row[i])];
			q = itoa(row[i], q, 10);

			out = space(SPACING - digits(row[i])) + apstring(q);
			cout << out;
			send_text(window, out);
		}
		send_text(window, "\n");
		cout << endl;
	}
}

// Return the number of base 10 decimal digits in n, for printing
int digits(int n)
{
	int digits = 0;

	if (n < 0)
		digits += 1;  // Account for "-" sign

	while(n)
	{
		n /= 10;
		digits++;
	}

	return digits;
}

// Return 'n' number of spaces
apstring space(int n)
{
	return rep(' ', n);
}

// Repeat character 'ch' 'n' number of times
apstring rep(int ch, int n)
{
	apstring s;

	if (n < 0)
	{
		cout << "Negative repetition count " << n << " in rep, not enough space, bailing out." << endl;
		cout << "Hint: Try a lower maximum" << endl;
		exit(-3);
	}

	while(n--)
		s += ch;

	return s;
}

void send_text(HWND w, apstring s)
{
	for(int i = 0; i < s.length(); i++)
		::SendMessage(w, WM_CHAR, s[i], 0);
}
