/* Jeff Connelly
 * Chapter 9 Lab 1 - Selection Sort & Binary Search
 * 31 Oct 2002
 */

#include <iostream.h>
#include <apvector.h>
#include <apstring.h>
#include <math.h>


typedef struct tagBSEARCH_DATA
{
	int index;
	int iterations;
	int maxiter;
} BSEARCH_DATA;


void selsort(apvector<int>&);       // in-place selection sort
BSEARCH_DATA bsearch(apvector<int>&, int t); // binary search

int main()
{
	while(1)
	{
		apvector<int> ints(0, 0);
		int target;

		cout << "Enter in a series of integers, separated by <enter>." << endl;
		cout << "Enter a BLANK LINE to end the process. 0 is valid input." << endl;

		// Read array
		while(1)
		{
			apstring str_input;

			getline(cin, str_input);
			if (str_input.length() == 0)
				break;

			if (str_input == "fill")
			{
				ints.resize(ints.length() + 100);
			}

			ints.resize(ints.length() + 1);
			ints[ints.length() - 1] = atoi(str_input.c_str());
		}
		cout << "Unsorted: ";
		for (int i = 0; i < ints.length(); i++)
			cout << ints[i] << " ";
		cout << endl;
		
		selsort(ints);

		cout << "Sorted: ";
		for (int j = 0; j < ints.length(); j++)
			cout << ints[j] << " ";
		cout << endl;

		do
		{
			apstring str_target;

			cout << "Enter a number to search for: ";
			getline(cin, str_target);
			if (str_target.length() == 0)
				continue;
			target = atoi(str_target.c_str());
		} while(0);   // bare block- {...}, C++ version
		//cout << "Searching for " << target << "..." << endl;

		BSEARCH_DATA bs = bsearch(ints, target);
		// TODO: Make arrow 
		//cout << "       " << repeat(' ', bs.index) << "^" << endl;
		cout << "Found " << target << " at index " << bs.index << endl;
		cout << "- Took " << bs.iterations << " iterations" << endl;
		// Solve 2^x = a.length()-1
		// log2(a.length()-1) = x
		// log(a.length()-1)/log(2)=x
		// logn(a) = log(a)/log(n)
		cout << "- Maximum possible iterations " << bs.maxiter << "\t 2^" <<
			bs.maxiter << " = " << pow(bs.maxiter, 2) << endl;
	}
	return 0;
}

// numbers (unsorted): 
// Enter a number to search for:
//
// numbers (sorted):
// The number X has been found
// It took N loops to find it

void swap(int &a, int &b)
{
    int temp = a;
	a = b;
	b = temp;
}

// In-place Descending Selection Sort: An incremental sorting algorithm
void selsort(apvector<int>& a)
{
	for (int i = 0; i < a.length() - 1; i++) // In lists of successively shorter length...
	{
		int max = i;       // Maximum valued index, initially first
		
		// Find maximum
		for (int j = i + 1; j < a.length(); j++)
		{
			if (a[j] > a[max])
				max = j;
		}

		// Swap a[i],a[max]
		swap(a[i], a[max]);
		/*
		int temp = a[i];
		a[i] = a[max];
		a[max] = temp;*/
	}
}

apstring repeat(int c, int times)
{
	apstring s;

	while(times--)
		s += c;
	return s;
}

// Find t inside a
BSEARCH_DATA bsearch(apvector<int>& a, int target)
{
	int left = 0, right = a.length() - 1, middle;
	BSEARCH_DATA ret;
	
	ret.iterations = 0;

	while (left <= right)
	{
		ret.iterations++;

		// Takes the index of the middle element between left and right
		middle = (left + right) / 2;

		if (target == a[middle])       // Found it
		{
			ret.maxiter = (int)ceil(log(a.length() - 1) / log(2));
			return ret;
		}

		if (target < a[middle])        // Go left more
			left = middle + 1;
		else                           // Go right more
			right = middle - 1;

	}

	ret.index = -1;
	return ret;
}