/* Jeff Connelly
 * Ch 12 Cooney
 * Character-oriented object notification environment, yo
 */

#include <apstring.h>
#include <bool.h>

// True if contains adjacant repeated characters
bool cooney_likes(const apstring& word);

int main()
{
	apstring word;

	cout << "Try to figure out what Cooney likes: " << endl
		<< endl
		<< "Cooney likes C++ but he doesn't like C" << endl
		<< "Cooney likes WWW but he doesn't like FTP" << endl
		<< "Cooney likes Google but doesn't like Altavista" << endl
		<< endl;
	
	for(;;)
	{
		cout << "Does Cooney like... (enter word) ==> ";
		getline(cin, word);
		if (cooney_likes(word))
			cout << "Yes, Cooney likes " << word << endl;
		else
			cout << "No, Cooney doesn't like " << word << endl;
	}

	return 0;
}

// True if adjacent equal characters
// Perl equivalent:
//
// sub cooney_likes { return $_[0] =~ m/(.)\1/ }
//
bool cooney_likes(const apstring& word)
{
	int i;

	for (i = 1; i < word.length(); i++)   // Start at 1 becaue 1-1=0, first index
		if (tolower(word[i]) == tolower(word[i - 1]))      // this vs. previous character
			return true;      // if equal, character likes
	return false;
} 
