/* Jeff Connelly
 * 03 Dec 2002
 * C++ You++ Minilab - Dates Using Structures
 */

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>

struct DATE
{
	int month;
	int day;
	int year;
};

istream& operator>>(istream& is, DATE& date);
ostream& operator<<(ostream& os, const DATE& d);

int main()
{
	DATE date;
	do
	{
		cin >> date;
		cout << date;

		// Other holidays:
		// thanksgiving - fourth Thursday of November
		switch(date.month * 31 + date.day)
		{
		case  1*31+ 1: cout << "It's New Year's Day" << endl; break;     //  1 january
		case  2*31+ 2: cout << "It's Groundhog's Day" << endl; break;    //  2 february
		case  2*31+14: cout << "It's Valentine's Day!" << endl; break;   // 14 february
		case  3*31+17: cout << "It's St. Patrick's Day" << endl; break;  // 17 march
		case  3*31+20: cout << "It's the Vernal Equinox!" << endl; break;// 20 march
		case  7*31+ 4: cout << "It's Independence Day" << endl; break;   //  4 july
		case  7*31+28: cout << "It's my birthday!" << endl; break;       // 28 july
		case 10*31+12: cout << "It's Columbus Day" << endl; break;       // 12 october
		case 10*31+31: cout << "It's Halloween!" << endl; break;         // 31 october
		case 12*31+25: cout << "It's Christmas!" << endl; break;         // 25 december
		}
	} while(1);
	return 0;
}

// Overloaded ostream operator<< to allow for cout<<date
ostream& operator<<(ostream& os, const DATE& d)
{
	cout.setf(ios::right | ios::adjustfield);
	cout << setfill('0')
		 << setw(2) << d.month << '-'
		 << setw(2) << d.day << '-'
		 << setw(4) << d.year
		 << setfill(' ')
		 << endl;
	return os;
}

// Overloaded istream operator>> to allow for cin>>date
istream& operator>>(istream& is, DATE& date)
{
	do
	{
		cout << "Please enter a month: ";
		cin >> date.month;
		if (date.month <= 0 || date.month > 12)
		{
			cout << "Between 1 and 12." << endl;
			continue;
		}
	} while(0);

	do
	{
		cout << "Please enter a day: ";
		cin >> date.day;
		if (date.day <= 0 || date.day > 31)
		{
			cout << "Between 1 and 31." << endl;
			continue;
		}
	} while(0);

	do
	{
		cout << "Please enter a year: ";
		cin >> date.year;
		if (date.year < 0)
		{
			cout << "No negative years" << endl;
			continue;
		}
	} while(0);
	return is;
}
