// Circle Class
//  The definition for objects which represent circles

#ifndef _CIRCLE_H                 // see if the circle class has been defined
#define _CIRCLE_H                 // if not, define it

const double PI = 3.14159;        // constant of ratio of diameter to circumference
                                  // blank line preceeding class declaration
class Circle                      // begin declaration of a new data type class Circle
{                                 // opening brace starts declaration
public:                           // following methods/data is publically accessible
	  // constructors
	  Circle(double r=0.0);       // default and one-argument constructor -
	  Circle(const Circle &);     // copy constructor
                                  // separation of constructors and accessors
	  // accessor functions
	  double SetRadius(double);   // sets radius member data and returns new value
	  double Area();              // calculates circle area from radius stored in radius
	  double Circumference();     // calculates and returns circumference
	  double Diameter();          // calculates and returns diameter
	                              // (formerly-) blank line for stylistic purposes
 private:                         // begins private declaration of internal data
	  double radius;              // private member radius storing data
};                                // end of class declaration; notice terminating semicolon
                                  // blank line after class declaration

#endif                            // #ifndef _CIRCLE_H end of inclusion guard
